Index: src/binutils/libiberty/cplus-dem.c
===================================================================
RCS file: /gccos2/src/binutils/libiberty/cplus-dem.c,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/libiberty/cplus-dem.c	16 Aug 2003 16:57:34 -0000	1.1.1.2
+++ src/binutils/libiberty/cplus-dem.c	11 Jan 2004 18:11:02 -0000	1.2
@@ -4889,3 +4889,341 @@
   sprintf(buf, "T%d", idx);
   string_append (s, buf);
 }
+
+/* bird: This was put back since we're building some older gcc, remove
+         when going for gcc which doesn't expect MAIN and main().
+ */
+
+/* To generate a standalone demangler program for testing purposes,
+   just compile and link this file with -DMAIN and libiberty.a.  When
+   run, it demangles each command line arg, or each stdin string, and
+   prints the result on stdout.  */
+
+#ifdef MAIN
+
+#include "getopt.h"
+
+static const char *program_name;
+static const char *program_version = VERSION;
+static int flags = DMGL_PARAMS | DMGL_ANSI | DMGL_VERBOSE;
+
+static void demangle_it PARAMS ((char *));
+static void usage PARAMS ((FILE *, int)) ATTRIBUTE_NORETURN;
+static void fatal PARAMS ((const char *)) ATTRIBUTE_NORETURN;
+static void print_demangler_list PARAMS ((FILE *));
+
+static void
+demangle_it (mangled_name)
+     char *mangled_name;
+{
+  char *result;
+
+  /* For command line args, also try to demangle type encodings.  */
+  result = cplus_demangle (mangled_name, flags | DMGL_TYPES);
+  if (result == NULL)
+    {
+      printf ("%s\n", mangled_name);
+    }
+  else
+    {
+      printf ("%s\n", result);
+      free (result);
+    }
+}
+
+static void
+print_demangler_list (stream)
+     FILE *stream;
+{
+  const struct demangler_engine *demangler;
+
+  fprintf (stream, "{%s", libiberty_demanglers->demangling_style_name);
+
+  for (demangler = libiberty_demanglers + 1;
+       demangler->demangling_style != unknown_demangling;
+       ++demangler)
+    fprintf (stream, ",%s", demangler->demangling_style_name);
+
+  fprintf (stream, "}");
+}
+
+static void
+usage (stream, status)
+     FILE *stream;
+     int status;
+{
+  fprintf (stream, "\
+Usage: %s [-_] [-n] [--strip-underscores] [--no-strip-underscores] \n",
+	   program_name);
+
+  fprintf (stream, "\
+       [-s ");
+  print_demangler_list (stream);
+  fprintf (stream, "]\n");
+
+  fprintf (stream, "\
+       [--format ");
+  print_demangler_list (stream);
+  fprintf (stream, "]\n");
+
+  fprintf (stream, "\
+       [--help] [--version] [arg...]\n");
+  exit (status);
+}
+
+#define MBUF_SIZE 32767
+char mbuffer[MBUF_SIZE];
+
+/* Defined in the automatically-generated underscore.c.  */
+extern int prepends_underscore;
+
+int strip_underscore = 0;
+
+static const struct option long_options[] = {
+  {"strip-underscores", no_argument, 0, '_'},
+  {"format", required_argument, 0, 's'},
+  {"help", no_argument, 0, 'h'},
+  {"no-strip-underscores", no_argument, 0, 'n'},
+  {"version", no_argument, 0, 'v'},
+  {0, no_argument, 0, 0}
+};
+
+/* More 'friendly' abort that prints the line and file.
+   config.h can #define abort fancy_abort if you like that sort of thing.  */
+
+void
+fancy_abort ()
+{
+  fatal ("Internal gcc abort.");
+}
+
+
+static const char *
+standard_symbol_characters PARAMS ((void));
+
+static const char *
+hp_symbol_characters PARAMS ((void));
+
+static const char *
+gnu_v3_symbol_characters PARAMS ((void));
+
+/* Return the string of non-alnum characters that may occur
+   as a valid symbol component, in the standard assembler symbol
+   syntax.  */
+
+static const char *
+standard_symbol_characters ()
+{
+  return "_$.";
+}
+
+
+/* Return the string of non-alnum characters that may occur
+   as a valid symbol name component in an HP object file.
+
+   Note that, since HP's compiler generates object code straight from
+   C++ source, without going through an assembler, its mangled
+   identifiers can use all sorts of characters that no assembler would
+   tolerate, so the alphabet this function creates is a little odd.
+   Here are some sample mangled identifiers offered by HP:
+
+	typeid*__XT24AddressIndExpClassMember_
+	[Vftptr]key:__dt__32OrdinaryCompareIndExpClassMemberFv
+	__ct__Q2_9Elf64_Dyn18{unnamed.union.#1}Fv
+
+   This still seems really weird to me, since nowhere else in this
+   file is there anything to recognize curly brackets, parens, etc.
+   I've talked with Srikanth <srikanth@cup.hp.com>, and he assures me
+   this is right, but I still strongly suspect that there's a
+   misunderstanding here.
+
+   If we decide it's better for c++filt to use HP's assembler syntax
+   to scrape identifiers out of its input, here's the definition of
+   the symbol name syntax from the HP assembler manual:
+
+       Symbols are composed of uppercase and lowercase letters, decimal
+       digits, dollar symbol, period (.), ampersand (&), pound sign(#) and
+       underscore (_). A symbol can begin with a letter, digit underscore or
+       dollar sign. If a symbol begins with a digit, it must contain a
+       non-digit character.
+
+   So have fun.  */
+static const char *
+hp_symbol_characters ()
+{
+  return "_$.<>#,*&[]:(){}";
+}
+
+
+/* Return the string of non-alnum characters that may occur
+   as a valid symbol component in the GNU C++ V3 ABI mangling
+   scheme.  */
+
+static const char *
+gnu_v3_symbol_characters ()
+{
+  return "_$.";
+}
+
+
+extern int main PARAMS ((int, char **));
+
+int
+main (argc, argv)
+     int argc;
+     char **argv;
+{
+  char *result;
+  int c;
+  const char *valid_symbols;
+  enum demangling_styles style = auto_demangling;
+
+  program_name = argv[0];
+
+  strip_underscore = prepends_underscore;
+
+  while ((c = getopt_long (argc, argv, "_ns:", long_options, (int *) 0)) != EOF)
+    {
+      switch (c)
+	{
+	case '?':
+	  usage (stderr, 1);
+	  break;
+	case 'h':
+	  usage (stdout, 0);
+	case 'n':
+	  strip_underscore = 0;
+	  break;
+	case 'v':
+	  printf ("GNU %s (C++ demangler), version %s\n", program_name, program_version);
+	  return (0);
+	case '_':
+	  strip_underscore = 1;
+	  break;
+	case 's':
+	  {
+	    style = cplus_demangle_name_to_style (optarg);
+	    if (style == unknown_demangling)
+	      {
+		fprintf (stderr, "%s: unknown demangling style `%s'\n",
+			 program_name, optarg);
+		return (1);
+	      }
+	    else
+	      cplus_demangle_set_style (style);
+	  }
+	  break;
+	}
+    }
+
+  if (optind < argc)
+    {
+      for ( ; optind < argc; optind++)
+	{
+	  demangle_it (argv[optind]);
+	}
+    }
+  else
+    {
+      switch (current_demangling_style)
+	{
+	case gnu_demangling:
+	case lucid_demangling:
+	case arm_demangling:
+	case java_demangling:
+	case edg_demangling:
+	case gnat_demangling:
+	case auto_demangling:
+	  valid_symbols = standard_symbol_characters ();
+	  break;
+	case hp_demangling:
+	  valid_symbols = hp_symbol_characters ();
+	  break;
+	case gnu_v3_demangling:
+	  valid_symbols = gnu_v3_symbol_characters ();
+	  break;
+	default:
+	  /* Folks should explicitly indicate the appropriate alphabet for
+	     each demangling.  Providing a default would allow the
+	     question to go unconsidered.  */
+	  abort ();
+	}
+
+      for (;;)
+	{
+	  int i = 0;
+	  c = getchar ();
+	  /* Try to read a label.  */
+	  while (c != EOF && (ISALNUM (c) || strchr (valid_symbols, c)))
+	    {
+	      if (i >= MBUF_SIZE-1)
+		break;
+	      mbuffer[i++] = c;
+	      c = getchar ();
+	    }
+	  if (i > 0)
+	    {
+	      int skip_first = 0;
+
+	      if (mbuffer[0] == '.' || mbuffer[0] == '$')
+		++skip_first;
+	      if (strip_underscore && mbuffer[skip_first] == '_')
+		++skip_first;
+
+	      if (skip_first > i)
+		skip_first = i;
+
+	      mbuffer[i] = 0;
+	      flags |= (int) style;
+	      result = cplus_demangle (mbuffer + skip_first, flags);
+	      if (result)
+		{
+		  if (mbuffer[0] == '.')
+		    putc ('.', stdout);
+		  fputs (result, stdout);
+		  free (result);
+		}
+	      else
+		fputs (mbuffer, stdout);
+
+	      fflush (stdout);
+	    }
+	  if (c == EOF)
+	    break;
+	  putchar (c);
+	  fflush (stdout);
+	}
+    }
+
+  return (0);
+}
+
+static void
+fatal (str)
+     const char *str;
+{
+  fprintf (stderr, "%s: %s\n", program_name, str);
+  exit (1);
+}
+
+PTR
+xmalloc (size)
+  size_t size;
+{
+  register PTR value = (PTR) malloc (size);
+  if (value == 0)
+    fatal ("virtual memory exhausted");
+  return value;
+}
+
+PTR
+xrealloc (ptr, size)
+  PTR ptr;
+  size_t size;
+{
+  register PTR value = (PTR) realloc (ptr, size);
+  if (value == 0)
+    fatal ("virtual memory exhausted");
+  return value;
+}
+#endif	/* main */
Index: src/binutils/libiberty/getpwd.c
===================================================================
RCS file: /gccos2/src/binutils/libiberty/getpwd.c,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/libiberty/getpwd.c	16 Aug 2003 16:57:37 -0000	1.1.1.2
+++ src/binutils/libiberty/getpwd.c	17 Aug 2003 01:48:59 -0000	1.2
@@ -56,7 +56,7 @@
 #define GUESSPATHLEN 100
 #endif
 
-#if !(defined (VMS) || (defined(_WIN32) && !defined(__CYGWIN__)))
+#if !(defined (VMS) || (defined(_WIN32) && !defined(__CYGWIN__)) || defined(__EMX__))
 
 /* Get the working directory.  Use the PWD environment variable if it's
    set correctly, since this is faster and gives more uniform answers
@@ -104,7 +104,7 @@
   return p;
 }
 
-#else	/* VMS || _WIN32 && !__CYGWIN__ */
+#else	/* VMS || _WIN32 && !__CYGWIN__ || __EMX__ */
 
 #ifndef MAXPATHLEN
 #define MAXPATHLEN 255
@@ -124,4 +124,4 @@
   return pwd;
 }
 
-#endif	/* VMS || _WIN32 && !__CYGWIN__ */
+#endif	/* VMS || _WIN32 && !__CYGWIN__ || __EMX__ */
Index: src/binutils/libiberty/lbasename.c
===================================================================
RCS file: /gccos2/src/binutils/libiberty/lbasename.c,v
retrieving revision 1.1.1.1
retrieving revision 1.2
diff -w -u -r1.1.1.1 -r1.2
--- src/binutils/libiberty/lbasename.c	16 Aug 2003 16:57:38 -0000	1.1.1.1
+++ src/binutils/libiberty/lbasename.c	17 Aug 2003 01:49:09 -0000	1.2
@@ -46,7 +46,7 @@
 #endif
 
 #if defined (_WIN32) || defined (__MSDOS__) \
-    || defined (__DJGPP__) || defined (__OS2__)
+    || defined (__DJGPP__) || defined (__OS2__) || defined (__EMX__)
 #  define HAVE_DOS_BASED_FILE_SYSTEM
 #  ifndef DIR_SEPARATOR_2 
 #    define DIR_SEPARATOR_2 '\\'
Index: src/binutils/libiberty/make-temp-file.c
===================================================================
RCS file: /gccos2/src/binutils/libiberty/make-temp-file.c,v
retrieving revision 1.1.1.1
retrieving revision 1.2
diff -w -u -r1.1.1.1 -r1.2
--- src/binutils/libiberty/make-temp-file.c	16 Aug 2003 16:57:39 -0000	1.1.1.1
+++ src/binutils/libiberty/make-temp-file.c	6 Feb 2004 11:13:21 -0000	1.2
@@ -126,7 +126,14 @@
   len = strlen (base);
   tmpdir = xmalloc (len + 2);
   strcpy (tmpdir, base);
+#ifdef __EMX__
+  if (tmpdir[len - 1] == '\\' || tmpdir[len - 1] == '/')
+    tmpdir[--len] = DIR_SEPARATOR;
+  else
   tmpdir[len] = DIR_SEPARATOR;
+#else
+  tmpdir[len] = DIR_SEPARATOR;
+#endif
   tmpdir[len+1] = '\0';
 
   memoized_tmpdir = tmpdir;
Index: src/binutils/libiberty/pex-os2.c
===================================================================
RCS file: /gccos2/src/binutils/libiberty/pex-os2.c,v
retrieving revision 1.1.1.1
retrieving revision 1.4
diff -w -u -r1.1.1.1 -r1.4
--- src/binutils/libiberty/pex-os2.c	16 Aug 2003 16:57:42 -0000	1.1.1.1
+++ src/binutils/libiberty/pex-os2.c	11 Jan 2004 16:51:02 -0000	1.4
@@ -21,6 +21,14 @@
 
 #include "pex-common.h"
 
+#include <stdio.h>
+#include <errno.h>
+#ifdef NEED_DECLARATION_ERRNO
+extern int errno;
+#endif
+#ifdef HAVE_STRING_H
+#include <string.h>
+#endif
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
@@ -31,9 +39,14 @@
 #include <sys/wait.h>
 #endif
 
-/* ??? Does OS2 have process.h?  */
-extern int spawnv ();
-extern int spawnvp ();
+#ifndef HAVE_WAITPID
+#define waitpid(pid, status, flags) wait(status)
+#endif
+
+#include <process.h>
+#define INCL_BASE
+#include <os2.h>
+#include <sys/fcntl.h>
 
 int
 pexecute (program, argv, this_pname, temp_base, errmsg_fmt, errmsg_arg, flags)
@@ -44,21 +57,91 @@
      char **errmsg_fmt, **errmsg_arg;
      int flags;
 {
+  static int last_pipe_input = STDIN_FILE_NO;
   int pid;
+  int pdes[2], org_stdin, org_stdout;
+  int input_desc = last_pipe_input;
+  int output_desc = STDOUT_FILE_NO;
+#ifdef __OS2__
+#define pipes_supported 1
+#else
+  int pipes_supported = _osmode != DOS_MODE || (_emx_env & 0x1000);
 
-  if ((flags & PEXECUTE_ONE) != PEXECUTE_ONE)
-    abort ();
-  /* ??? Presumably 1 == _P_NOWAIT.  */
-  pid = (flags & PEXECUTE_SEARCH ? spawnvp : spawnv) (1, program, argv);
-  if (pid == -1)
+  if (!pipes_supported && (flags & PEXECUTE_ONE) != PEXECUTE_ONE)
+    {
+      static char *errtpl = "%s: exec %s (pipes not supported)";
+      *errmsg_fmt = (char *) xmalloc (strlen(errtpl) + \
+                     strlen(this_pname) + strlen(program));
+      sprintf (*errmsg_fmt, errtpl, this_pname, program);
+      *errmsg_arg = NULL;
+      return -1;
+    }
+#endif
+
+  /* If this isn't the last process, make a pipe for its output,
+     and record it as waiting to be the input to the next process.  */
+  if (!(flags & PEXECUTE_LAST))
+    {
+      if (pipe (pdes) < 0)
     {
-      *errmsg_fmt = install_error_msg;
-      *errmsg_arg = program;
+          static char *errtpl = "%s: pipe to/from %s";
+          *errmsg_fmt = (char *) xmalloc (strlen(errtpl) + \
+                         strlen(this_pname) + strlen(program));
+          sprintf (*errmsg_fmt, errtpl, this_pname, program);
+          *errmsg_arg = NULL;
       return -1;
     }
+      output_desc = pdes[WRITE_PORT];
+      last_pipe_input = pdes[READ_PORT];
+      /* we don't wanna have an extra handles in the child. */
+      fcntl (pdes[READ_PORT], F_SETFD, FD_CLOEXEC);
+      fcntl (pdes[WRITE_PORT], F_SETFD, FD_CLOEXEC);
+    }
+  else
+    last_pipe_input = STDIN_FILE_NO;
+  if (pipes_supported && input_desc != STDIN_FILE_NO)
+    {
+      org_stdin = dup (STDIN_FILE_NO);
+      fcntl (org_stdin, F_SETFD, FD_CLOEXEC);
+      dup2 (input_desc, STDIN_FILE_NO);
+      fcntl (STDIN_FILE_NO, F_SETFD, 0); /* paranoia. but what's the deal with this flag over dup? */
+      close (input_desc);
+    }
+  if (pipes_supported && output_desc != STDOUT_FILE_NO)
+    {
+      org_stdout = dup (STDOUT_FILE_NO);
+      fcntl (org_stdout, F_SETFD, FD_CLOEXEC);
+      dup2 (output_desc, STDOUT_FILE_NO);
+      fcntl (STDOUT_FILE_NO, F_SETFD, 0); /* paranoia. but what's the deal with this flag over dup? */
+      close (output_desc);
+    }
+
+  pid = (flags & PEXECUTE_SEARCH ? spawnvp : spawnv) (P_NOWAIT, program, argv);
+
+  if (pipes_supported && input_desc != STDIN_FILE_NO)
+    {
+      dup2 (org_stdin, STDIN_FILE_NO);
+      fcntl (STDIN_FILE_NO, F_SETFD, 0); /* paranoia. but what's the deal with this flag over dup? */
+      close (org_stdin);
+    }
+  if (pipes_supported && output_desc != STDOUT_FILE_NO)
+    {
+      dup2 (org_stdout, STDOUT_FILE_NO);
+      fcntl (STDOUT_FILE_NO, F_SETFD, 0); /* paranoia. but what's the deal with this flag over dup? */
+      close (org_stdout);
+    }
+  if (pid == -1)
+    {
+      static char *errtpl = "%s: error executing %s";
+      *errmsg_fmt = (char *) xmalloc (strlen(errtpl) + \
+                     strlen(this_pname) + strlen(program));
+      sprintf (*errmsg_fmt, errtpl, this_pname, program);
+      *errmsg_arg = NULL;
+    }
   return pid;
 }
 
+
 int
 pwait (pid, status, flags)
      int pid;
@@ -67,6 +150,9 @@
 {
   /* ??? Here's an opportunity to canonicalize the values in STATUS.
      Needed?  */
-  int pid = wait (status);
-  return pid;
+  int rc;
+  do
+   rc = waitpid (pid, status, flags);
+  while (rc < 0 && errno == EINTR);
+  return rc;
 }
Index: src/binutils/libiberty/config/mh-emx
===================================================================
RCS file: src/binutils/libiberty/config/mh-emx
diff -N src/binutils/libiberty/config/mh-emx
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/libiberty/config/mh-emx	17 Aug 2003 01:48:07 -0000	1.2
@@ -0,0 +1,13 @@
+# r=bird: why this here? Should be sufficient to do -s when linking.
+#CFLAGS = -s -O2
+INSTALL = cp
+
+# Add the "s" flag to AR_FLAGS to add an archive index instead of RANLIB
+AR_FLAGS = rcs
+
+# hack: Instead of ranlib run dllar which will make a shared library (dll)
+#       TODO: Don't use RANLIB because it f**ks up install.
+#       TODO: Pass the correct -g/-s flag without using non-standard stuff.
+# bird: Forget this it breaks the install. We'll need a better hack.
+# override RANLIB = kRx.exe dllar.cmd -cc '$(CC)' -d 'The GNU -liberty library' -o iberty -lgcc
+
Index: src/binutils/opcodes/configure.in
===================================================================
RCS file: /gccos2/src/binutils/opcodes/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/opcodes/configure.in	16 Aug 2003 16:58:10 -0000	1.1.1.2
+++ src/binutils/opcodes/configure.in	13 Mar 2005 23:44:50 -0000	1.5
@@ -78,7 +78,7 @@
 
 AC_PROG_CC
 
-ALL_LINGUAS="fr sv tr es da de id pt_BR ro"
+ALL_LINGUAS="fr sv es da de id pt_BR ro"
 CY_GNU_GETTEXT
 
 . ${srcdir}/../bfd/configure.host
@@ -119,6 +119,13 @@
   if test "$enable_shared" = "yes"; then
     WIN32LDFLAGS="-no-undefined"
     WIN32LIBADD="-L`pwd`/../bfd -lbfd -L`pwd`/../libiberty -liberty -L`pwd`/../intl -lintl -lcygwin"
+  fi
+  ;;
+*-*-os2*)
+  if test "$enable_shared" = "yes"; then
+    WIN32LDFLAGS="-no-undefined"
+    WIN32LIBADD="-L`pwd`/../bfd -lbfd -L`pwd`/../libiberty -liberty"
+#    WIN32LIBADD="-L`pwd`/../bfd -lbfd -L`pwd`/../libiberty -liberty -L`pwd`/../intl -lintl"
   fi
   ;;
 esac
Index: src/binutils/opcodes/po/Make-in
===================================================================
RCS file: /gccos2/src/binutils/opcodes/po/Make-in,v
retrieving revision 1.1.1.1
retrieving revision 1.3
diff -w -u -r1.1.1.1 -r1.3
--- src/binutils/opcodes/po/Make-in	16 Apr 2003 14:15:28 -0000	1.1.1.1
+++ src/binutils/opcodes/po/Make-in	30 Jan 2004 16:07:38 -0000	1.3
@@ -30,10 +30,10 @@
 
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_IFS@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_IFS@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_IFS@$$PATH" msgmerge
 
 DEFS = @DEFS@
 CFLAGS = @CFLAGS@
@@ -208,7 +208,7 @@
 
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_IFS@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
 	for cat in $$catalogs; do \
